// Get all Activities und speichere die wichtige UID
<?php
// cURL-Session initialisieren
$ch = curl_init();
$PIN = '5312'; 
// cURL-Optionen festlegen
curl_setopt($ch, CURLOPT_URL, 'http://192.168.178.227/api/activities?page=1&limit=100');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'accept: application/json'
]);
curl_setopt($ch, CURLOPT_USERPWD, 'web-configurator:' . $PIN);
// Anfrage ausführen und Antwort speichern
$response = curl_exec($ch);
$Activities = array();
$Activities = ($response);
$Activities = json_decode($response,true);
// cURL-Session schließen
curl_close($ch);
foreach ($Activities as $Activity){
    $Parent = 27320;
// Kategorie Devices erzeugen
    $ActivityID = @IPS_GetObjectIDByName($Activity["name"]["en"], $Parent);
    if ($ActivityID == false){
        $ActivityID = IPS_CreateVariable(3);                                // Stringvariable anlegen
        IPS_SetName($ActivityID, $Activity["name"]["en"]);                  // Kategorie benennen
        IPS_SetParent($ActivityID, $Parent);                                // Kategorie einsortieren unter dem Objekt
    }
    SetValue($ActivityID, $Activity["entity_id"]);
}
?>

// Get Entities  und speichere die wichtige UID, Type, Features und Commands
<?php
// cURL-Session initialisieren
$ch = curl_init();
$PIN = '5312'; 
// cURL-Optionen festlegen
curl_setopt($ch, CURLOPT_URL, 'http://192.168.178.227/api/entities?page=1&limit=100');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'accept: application/json'
]);
curl_setopt($ch, CURLOPT_USERPWD, 'web-configurator:' . $PIN);
// Anfrage ausführen und Antwort speichern
$response = curl_exec($ch);
$Entities = array();
$Entities = ($response);
$Entities = json_decode($response,true);
// cURL-Session schließen
curl_close($ch);
foreach ($Entities as $Entity){
    $Parent = 48407;
// Kategorie Devices erzeugen
    $EntityID = @IPS_GetObjectIDByName($Entity["name"]["en"], $Parent);
    if ($EntityID == false){
        $EntityID = IPS_CreateCategory();                              // Kategorie anlegen
        IPS_SetName($EntityID, $Entity["name"]["en"]);                 // Kategorie benennen
        IPS_SetParent($EntityID, $Parent);                             // Kategorie einsortieren unter dem Objekt
    }
    $Parent = $EntityID;
    if (isset($Entity["entity_id"])){
        $EntityID = @IPS_GetObjectIDByName($Entity["entity_type"], $Parent);
        if ($EntityID == false){
            $EntityID = IPS_CreateVariable(3);                          // Stringvariable anlegen
            IPS_SetPosition($EntityID, 10);                             // Stringvariable positionieren
            IPS_SetName($EntityID, $Entity["entity_type"]);             // Stringvariable benennen
            IPS_SetParent($EntityID, $Parent);                          // Stringvariable einsortieren unter dem Objekt
        }
        SetValue($EntityID, $Entity["entity_id"]);
    }
    if (isset($Entity["features"])){
        foreach ($Entity["features"] as $Feature){
            $FeaturesID = @IPS_GetObjectIDByName("Features", $Parent);
            if ($FeaturesID == false){
                $FeaturesID = IPS_CreateVariable(3);                    // Stringvariable anlegen
                IPS_SetPosition($FeaturesID, 20);                       // Stringvariable positionieren
                IPS_SetName($FeaturesID, "Features");                   // Stringvariable benennen
                IPS_SetParent($FeaturesID, $Parent);                    // Stringvariable einsortieren unter dem Objekt
            }
            $Features = json_encode($Entity["features"]);
            SetValue($FeaturesID, $Features);
        }
    }
    if (isset($Entity["options"]["simple_commands"])){
        $SimpleCommandsID = @IPS_GetObjectIDByName("SimpleCommands", $Parent);
        if ($SimpleCommandsID == false){
            $SimpleCommandsID = IPS_CreateVariable(3);                  // Stringvariable anlegen
            IPS_SetPosition($SimpleCommandsID, 30);                     // Stringvariable positionieren
            IPS_SetName($SimpleCommandsID, "SimpleCommands");           // Stringvariable benennen
            IPS_SetParent($SimpleCommandsID, $Parent);                  // Stringvariable einsortieren unter dem Objekt
        }
        $SimpleCommands = json_encode($Entity["options"]["simple_commands"]);
        SetValue($SimpleCommandsID, $SimpleCommands);
    }
    if ($Entity["entity_type"] == "macro"){
        if (isset($Entity["options"]["sequence"])){
            $MacrosID = @IPS_GetObjectIDByName("Commands", $Parent);
            if ($MacrosID == false){
                $MacrosID = IPS_CreateVariable(3);                      // Stringvariable anlegen
                IPS_SetPosition($MacrosID, 40);                         // Stringvariable positionieren
                IPS_SetName($MacrosID, "Commands");                     // Stringvariable benennen
                IPS_SetParent($MacrosID, $Parent);                      // Stringvariable einsortieren unter dem Objekt
            }
            $string = '';
            foreach ($Entity["options"]["sequence"] as $Sequence){
                if (isset($Sequence["command"])){
                    $string .= $Sequence["command"]["cmd_id"] . ' , ';
                }
            }
            SetValue($MacrosID, $string);
        }

    }
//    var_dump($Entity["options"]["simple_commands"]);
}

// Antwort ausgeben
//var_dump($resArr);
?>

// Get all Macros und speichere die wichtige UID
<?php
// cURL-Session initialisieren
$ch = curl_init();
$PIN = '5312'; 
// cURL-Optionen festlegen
curl_setopt($ch, CURLOPT_URL, 'http://192.168.178.227/api/macros?page=1&limit=100');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'accept: application/json'
]);
curl_setopt($ch, CURLOPT_USERPWD, 'web-configurator:' . $PIN);
// Anfrage ausführen und Antwort speichern
$response = curl_exec($ch);
$Macros = array();
$Macros = ($response);
$Macros = json_decode($response,true);
// cURL-Session schließen
curl_close($ch);
foreach ($Macros as $Macro){
    $Parent = 39346;
// Kategorie Devices erzeugen
    $MacroID = @IPS_GetObjectIDByName($Macro["name"]["en"], $Parent);
    if ($MacroID == false){
        $MacroID = IPS_CreateVariable(3);                               // Stringvariable anlegen
        IPS_SetName($MacroID, $Macro["name"]["en"]);                    // Kategorie benennen
        IPS_SetParent($MacroID, $Parent);                               // Kategorie einsortieren unter dem Objekt
    }
    SetValue($MacroID, $Macro["entity_id"]);
}
?>

// Send Status
<?php
// cURL-Session initialisieren
$ch = curl_init();

// cURL-Optionen festlegen
curl_setopt($ch, CURLOPT_URL, 'http://192.168.178.227/api/pub/status');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, [
    'accept: application/json'
]);

// Anfrage ausführen und Antwort speichern
$response = curl_exec($ch);
$resArr = array();
$resArr = ($response);

$resArr = json_decode($response,true);

// cURL-Session schließen
curl_close($ch);

// Antwort ausgeben
//var_dump($resArr);
//return;

// RAM
SetValue(52479, $resArr["memory"]["total_memory"] / 1048576);
SetValue(29584, $resArr["memory"]["used_memory"] / 1048576);
SetValue(34483, $resArr["memory"]["available_memory"] / 1048576);

//FLASH
SetValue(12823, $resArr["filesystem"]["user_data"]["available"] / 1048576);
SetValue(16680, $resArr["filesystem"]["user_data"]["used"] / 1048576);

// LOAD
SetValue(17342, $resArr["load_avg"]["one"]);
SetValue(33786, $resArr["load_avg"]["five"]);
SetValue(46640, $resArr["load_avg"]["fifteen"]);

?>

// Send command
<?php
$IP = '192.168.178.227';
$PIN = '5312'; 
$cmd_id = strval($code);

$data = array(
    'cmd_id' => $cmd_id
);

$data_string = json_encode($data);

$ch = curl_init('http://' . $IP . '/api/entities/uc_androidtv_wz2.main.2222F1F523E5/command');
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    'Content-Type: application/json',
    'Content-Length: ' . strlen($data_string))
);
curl_setopt($ch, CURLOPT_USERPWD, 'web-configurator:' . $PIN);

$result = curl_exec($ch);

curl_close($ch);

//echo $result;
return;
?>

// Start/End Activity
<?php
/*
/entities/{entity_id}/command {"entity_id": <entityid>, "cmd_id": "activity.on"}
*/
$IP = '192.168.178.227';
$PIN = '5312'; 
$ch = curl_init('http://' . $IP . '/api/entities/uc.main.aefacc2e-6f9a-43a4-b2f3-d5df5a4c39a2/command');
$data = array(
    'entity_id' => "uc.main.aefacc2e-6f9a-43a4-b2f3-d5df5a4c39a2",
    'cmd_id' => 'activity.on',
//    'cmd_id' => 'activity.off',
);
$data_string = json_encode($data);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
curl_setopt($ch, CURLOPT_POSTFIELDS, $data_string);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_HTTPHEADER, array(
    'Content-Type: application/json',
    'Content-Length: ' . strlen($data_string))
);
curl_setopt($ch, CURLOPT_USERPWD, 'web-configurator:' . $PIN);
$result = curl_exec($ch);
curl_close($ch);
echo $result;
?>


